﻿using System;
using System.Collections.Generic;
using System.Linq;
using ApiWithMessagePack.Common;
using ApiWithMessagePack.Models;
using Microsoft.AspNetCore.Mvc;
using Microsoft.Extensions.Logging;

namespace ApiWithMessagePack.Controllers
{
    [ApiController]
    [Route("[controller]")]
    public class WeatherForecastController : ControllerBase
    {
        private static readonly string[] Summaries = new[]
        {
            "Freezing", "Bracing", "Chilly", "Cool", "Mild", "Warm", "Balmy", "Hot", "Sweltering", "Scorching"
        };

        private readonly ILogger<WeatherForecastController> _logger;

        public WeatherForecastController(ILogger<WeatherForecastController> logger)
        {
            _logger = logger;
        }

        [HttpGet]
        [Produces(Constants.MediaTypes.Output.WeatherMPack)]
        [AcceptStrict(Constants.MediaTypes.Output.WeatherMPack)]
        public IEnumerable<WeatherForecast> Get()
        {
            var rng = new Random();
            return Summaries.Select((summary, index) => new WeatherForecast
            {
                Date = DateTime.Now.AddDays(index),
                TemperatureC = rng.Next(-20, 55),
                Summary = summary
            })
            .ToArray();
        }
    }
}
