using ApiWithMessagePack.Client;
using ApiWithMessagePack.Models;
using Microsoft.AspNetCore.Mvc.Testing;
using NUnit.Framework;
using System.Net.Http;
using System.Threading.Tasks;

namespace ApiWithMessagePack.ClientTest
{
    public class Tests
    {
        private WeatherForecastClient WeatherForecastClient;

        [SetUp]
        public void Setup()
        {
            WebApplicationFactory<Startup> apiFactory = new WebApplicationFactory<Startup>();
            HttpClient apiHttpClient = apiFactory.CreateClient();
            
            WeatherForecastClient = new WeatherForecastClient(apiHttpClient);
        }

        [Test]
        public async Task Client_Get_Forecats_Should_Work()
        {
            WeatherForecast[] forecasts = await WeatherForecastClient.GetAsync().ConfigureAwait(false);

            Assert.That(forecasts[0].Summary, Is.EqualTo("Freezing"));
        }
    }
}